// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.data.vessel.feature.physical;

import fr.ifremer.adagio.core.dao.administration.programStrategy.Program;
import fr.ifremer.adagio.core.dao.data.measure.GearPhysicalMeasurement;
import fr.ifremer.adagio.core.dao.data.operation.Operation;
import fr.ifremer.adagio.core.dao.data.survey.activity.ActivityCalendar;
import fr.ifremer.adagio.core.dao.data.survey.fishingTrip.FishingTrip;
import fr.ifremer.adagio.core.dao.data.survey.physicalGear.PhysicalGearSurvey;
import fr.ifremer.adagio.core.dao.data.vessel.Vessel;
import fr.ifremer.adagio.core.dao.referential.QualityFlag;
import fr.ifremer.adagio.core.dao.referential.gear.Gear;
import fr.ifremer.adagio.core.dao.referential.metier.Metier;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.Date;
import java.util.HashSet;

/**
 * Caractéristiques d'un engin physique d'un navire (navire de peche ou océanographique, ou autres).
 * L'engin lié peut etre un engin de peche (Chalut, Filet, etc.) ou non (Sonde de température,
 * Sonar, etc.)
 */
// HibernateEntity.vsl annotations merge-point
public abstract class GearPhysicalFeatures
    extends PhysicalFeaturesImpl
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 3429047159329994353L;

    // Generate 1 attributes
    private Short rankOrder;

    /**
     * 
     * @return this.rankOrder Short
     */
    public Short getRankOrder()
    {
        return this.rankOrder;
    }

    /**
     * 
     * @param rankOrderIn Short
     */
    public void setRankOrder(Short rankOrderIn)
    {
        this.rankOrder = rankOrderIn;
    }

    // Generate 9 associations
    private ActivityCalendar activityCalendar;

    /**
     * 
     * @return this.activityCalendar ActivityCalendar
     */
    public ActivityCalendar getActivityCalendar()
    {
        return this.activityCalendar;
    }

    /**
     * 
     * @param activityCalendarIn ActivityCalendar
     */
    public void setActivityCalendar(ActivityCalendar activityCalendarIn)
    {
        this.activityCalendar = activityCalendarIn;
    }

    private Gear otherGear;

    /**
     * @deprecated utilisation à éviter (utilisé pour les migrations de données essentiellement)
     * @return this.otherGear Gear
     */
    public Gear getOtherGear()
    {
        return this.otherGear;
    }

    /**
     * @deprecated utilisation à éviter (utilisé pour les migrations de données essentiellement)
     * @param otherGearIn Gear
     */
    public void setOtherGear(Gear otherGearIn)
    {
        this.otherGear = otherGearIn;
    }

    private Collection<Operation> operations = new HashSet<Operation>();

    /**
     * Opération éffectuée dans le cadre d'une marée (observée en mer, observée au débarquement,
     * campagne
     * en mer,  marée déclarée, etc.).
     * Une opération peut etre une opération de peche ou non. Par exemple, au cours de campagne à la
     * mer,
     * le navire peut déployer des engins de collecte de données environnementales (température,
     * salinité,
     * etc. ).
     * @return this.operations Collection<Operation>
     */
    public Collection<Operation> getOperations()
    {
        return this.operations;
    }

    /**
     * Opération éffectuée dans le cadre d'une marée (observée en mer, observée au débarquement,
     * campagne
     * en mer,  marée déclarée, etc.).
     * Une opération peut etre une opération de peche ou non. Par exemple, au cours de campagne à la
     * mer,
     * le navire peut déployer des engins de collecte de données environnementales (température,
     * salinité,
     * etc. ).
     * @param operationsIn Collection<Operation>
     */
    public void setOperations(Collection<Operation> operationsIn)
    {
        this.operations = operationsIn;
    }

    /**
     * Opération éffectuée dans le cadre d'une marée (observée en mer, observée au débarquement,
     * campagne
     * en mer,  marée déclarée, etc.).
     * Une opération peut etre une opération de peche ou non. Par exemple, au cours de campagne à la
     * mer,
     * le navire peut déployer des engins de collecte de données environnementales (température,
     * salinité,
     * etc. ).
     * @param elementToAdd Operation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addOperations(Operation elementToAdd)
    {
        return this.operations.add(elementToAdd);
    }

    /**
     * Opération éffectuée dans le cadre d'une marée (observée en mer, observée au débarquement,
     * campagne
     * en mer,  marée déclarée, etc.).
     * Une opération peut etre une opération de peche ou non. Par exemple, au cours de campagne à la
     * mer,
     * le navire peut déployer des engins de collecte de données environnementales (température,
     * salinité,
     * etc. ).
     * @param elementToRemove Operation
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeOperations(Operation elementToRemove)
    {
        return this.operations.remove(elementToRemove);
    }

    private FishingTrip fishingTrip;

    /**
     * Voyage en mer, ayant pour vocation une activité de peche (peut etre une campagnes halieutique
     * ou une
     * marée d'un navire professionnel, etc.)
     * Un voyage peut représenter type de données :
     * - Une marée observée (en mer, au débarquement), qui désigne une marée de pêche
     * professionnelle au
     * cours de laquelle des relevés sont effectués par un observateur.
     * - Une marée déclarée. Principalement issue du log book électronique (flux SACAPT). Une marée
     * déclarée peut etre un ensemble de marée ou de sous-ensembles de marée (Exemple de la fiche de
     * peche)
     * - une sortie effectuée lors d"une campagne scientifique
     * @return this.fishingTrip FishingTrip
     */
    public FishingTrip getFishingTrip()
    {
        return this.fishingTrip;
    }

    /**
     * Voyage en mer, ayant pour vocation une activité de peche (peut etre une campagnes halieutique
     * ou une
     * marée d'un navire professionnel, etc.)
     * Un voyage peut représenter type de données :
     * - Une marée observée (en mer, au débarquement), qui désigne une marée de pêche
     * professionnelle au
     * cours de laquelle des relevés sont effectués par un observateur.
     * - Une marée déclarée. Principalement issue du log book électronique (flux SACAPT). Une marée
     * déclarée peut etre un ensemble de marée ou de sous-ensembles de marée (Exemple de la fiche de
     * peche)
     * - une sortie effectuée lors d"une campagne scientifique
     * @param fishingTripIn FishingTrip
     */
    public void setFishingTrip(FishingTrip fishingTripIn)
    {
        this.fishingTrip = fishingTripIn;
    }

    private PhysicalGearSurvey physicalGearSurvey;

    /**
     * Enquete sur les engins physiques d'un navire et leurs caractéristiques.
     * @return this.physicalGearSurvey PhysicalGearSurvey
     */
    public PhysicalGearSurvey getPhysicalGearSurvey()
    {
        return this.physicalGearSurvey;
    }

    /**
     * Enquete sur les engins physiques d'un navire et leurs caractéristiques.
     * @param physicalGearSurveyIn PhysicalGearSurvey
     */
    public void setPhysicalGearSurvey(PhysicalGearSurvey physicalGearSurveyIn)
    {
        this.physicalGearSurvey = physicalGearSurveyIn;
    }

    private Gear gear;

    /**
     * Engin du référentiel qui correspond à l'engin physique décrit par les caractéristiques.
     * @return this.gear Gear
     */
    public Gear getGear()
    {
        return this.gear;
    }

    /**
     * Engin du référentiel qui correspond à l'engin physique décrit par les caractéristiques.
     * @param gearIn Gear
     */
    public void setGear(Gear gearIn)
    {
        this.gear = gearIn;
    }

    private Collection<GearPhysicalFeaturesOrigin> gearPhysicalFeaturesOrigins = new HashSet<GearPhysicalFeaturesOrigin>();

    /**
     * 
     * @return this.gearPhysicalFeaturesOrigins Collection<GearPhysicalFeaturesOrigin>
     */
    public Collection<GearPhysicalFeaturesOrigin> getGearPhysicalFeaturesOrigins()
    {
        return this.gearPhysicalFeaturesOrigins;
    }

    /**
     * 
     * @param gearPhysicalFeaturesOriginsIn Collection<GearPhysicalFeaturesOrigin>
     */
    public void setGearPhysicalFeaturesOrigins(Collection<GearPhysicalFeaturesOrigin> gearPhysicalFeaturesOriginsIn)
    {
        this.gearPhysicalFeaturesOrigins = gearPhysicalFeaturesOriginsIn;
    }

    /**
     * 
     * @param elementToAdd GearPhysicalFeaturesOrigin
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addGearPhysicalFeaturesOrigins(GearPhysicalFeaturesOrigin elementToAdd)
    {
        return this.gearPhysicalFeaturesOrigins.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove GearPhysicalFeaturesOrigin
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeGearPhysicalFeaturesOrigins(GearPhysicalFeaturesOrigin elementToRemove)
    {
        return this.gearPhysicalFeaturesOrigins.remove(elementToRemove);
    }

    private Metier metier;

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * M&#233;tier, qui peut etre un m&#233;tier de peche ou non.<br><br>Un
     * m&#233;tier de peche a obligatoirement une esp&#232;ce cible (TaxonGroup) de
     * d&#233;fini, et &#233;ventuellement un engin (Gear).
     * </p>
     * <p>
     * Dans ce cas, le nom (name) et le mn&#233;monique (label) pourront etre
     * d&#233;termin&#233; par la concat&#233;nation de l'engin et de l'esp&#232;ce cible.
     * </p>
     * <p>
     * <br>
     * <br>
     * </p>
     * <p>
     * <u>V2.1 </u>: modification de la gestion des m&#233;tiers : suppression des
     * classes FishingMetierGearType et MetierSpecies : un m&#233;tier est
     * maintenant d&#233;fini directement par Gear et TaxonGroup.<br><br>=&gt; Le
     * r&#233;f&#233;rentiel des engin du m&#233;tier (FishingMetierGearType) est maintenent
     * int&#233;gr&#233; au r&#233;f&#233;rentiel g&#233;n&#233;rique des engins<br>
     * </p>
     * <p>
     * </p>
     * <p>
     * =&gt; Le r&#233;f&#233;rentiel des esp&#232;ces m&#233;tier (MetierSpecies) est maintenent
     * int&#233;gr&#233; au r&#233;f&#233;rentiel g&#233;n&#233;rique des groupes de taxon<br><br>
     * </p>
     * <p>
     * <u>V3 </u>:<br>- Le m&#233;tier de peche n'a pas forc&#233;ment d'engin
     * (optionnel) Ex : AQUNEP
     * </p>
     * <p>
     * (Aquaculture)<br>- le mn&#233;monique et le libell&#233; ne sont plus calcul&#233;s &#224;
     * la vol&#233;e par concat&#233;nation, pour permettre l'utilisation de libell&#233; plus
     * court..
     * </p>
     * </body>
     * </html>
     * @return this.metier Metier
     */
    public Metier getMetier()
    {
        return this.metier;
    }

    /**
     * <html>
     * <head>
     * </head>
     * <body>
     * <p>
     * M&#233;tier, qui peut etre un m&#233;tier de peche ou non.<br><br>Un
     * m&#233;tier de peche a obligatoirement une esp&#232;ce cible (TaxonGroup) de
     * d&#233;fini, et &#233;ventuellement un engin (Gear).
     * </p>
     * <p>
     * Dans ce cas, le nom (name) et le mn&#233;monique (label) pourront etre
     * d&#233;termin&#233; par la concat&#233;nation de l'engin et de l'esp&#232;ce cible.
     * </p>
     * <p>
     * <br>
     * <br>
     * </p>
     * <p>
     * <u>V2.1 </u>: modification de la gestion des m&#233;tiers : suppression des
     * classes FishingMetierGearType et MetierSpecies : un m&#233;tier est
     * maintenant d&#233;fini directement par Gear et TaxonGroup.<br><br>=&gt; Le
     * r&#233;f&#233;rentiel des engin du m&#233;tier (FishingMetierGearType) est maintenent
     * int&#233;gr&#233; au r&#233;f&#233;rentiel g&#233;n&#233;rique des engins<br>
     * </p>
     * <p>
     * </p>
     * <p>
     * =&gt; Le r&#233;f&#233;rentiel des esp&#232;ces m&#233;tier (MetierSpecies) est maintenent
     * int&#233;gr&#233; au r&#233;f&#233;rentiel g&#233;n&#233;rique des groupes de taxon<br><br>
     * </p>
     * <p>
     * <u>V3 </u>:<br>- Le m&#233;tier de peche n'a pas forc&#233;ment d'engin
     * (optionnel) Ex : AQUNEP
     * </p>
     * <p>
     * (Aquaculture)<br>- le mn&#233;monique et le libell&#233; ne sont plus calcul&#233;s &#224;
     * la vol&#233;e par concat&#233;nation, pour permettre l'utilisation de libell&#233; plus
     * court..
     * </p>
     * </body>
     * </html>
     * @param metierIn Metier
     */
    public void setMetier(Metier metierIn)
    {
        this.metier = metierIn;
    }

    private Collection<GearPhysicalMeasurement> gearPhysicalMeasurements = new HashSet<GearPhysicalMeasurement>();

    /**
     * 
     * @return this.gearPhysicalMeasurements Collection<GearPhysicalMeasurement>
     */
    public Collection<GearPhysicalMeasurement> getGearPhysicalMeasurements()
    {
        return this.gearPhysicalMeasurements;
    }

    /**
     * 
     * @param gearPhysicalMeasurementsIn Collection<GearPhysicalMeasurement>
     */
    public void setGearPhysicalMeasurements(Collection<GearPhysicalMeasurement> gearPhysicalMeasurementsIn)
    {
        this.gearPhysicalMeasurements = gearPhysicalMeasurementsIn;
    }

    /**
     * 
     * @param elementToAdd GearPhysicalMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addGearPhysicalMeasurements(GearPhysicalMeasurement elementToAdd)
    {
        return this.gearPhysicalMeasurements.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove GearPhysicalMeasurement
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeGearPhysicalMeasurements(GearPhysicalMeasurement elementToRemove)
    {
        return this.gearPhysicalMeasurements.remove(elementToRemove);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>PhysicalFeaturesImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.vessel.feature.physical.PhysicalFeatures#equals(Object)
     */
    @Override
    public boolean equals(Object object)
    {
        return super.equals(object);
    }

    /**
     * This entity does not have any identifiers
     * but since it extends the <code>PhysicalFeaturesImpl</code> class
     * it will simply delegate the call up there.
     *
     * @see fr.ifremer.adagio.core.dao.data.vessel.feature.physical.PhysicalFeatures#hashCode()
     */
    @Override
    public int hashCode()
    {
        return super.hashCode();
    }

    /**
     * Constructs new instances of {@link GearPhysicalFeatures}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link GearPhysicalFeatures}.
         * @return new GearPhysicalFeaturesImpl()
         */
        public static GearPhysicalFeatures newInstance()
        {
            return new GearPhysicalFeaturesImpl();
        }

        /**
         * Constructs a new instance of {@link GearPhysicalFeatures}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param creationDate Date
         * @param program Program
         * @param qualityFlag QualityFlag
         * @param vessel Vessel
         * @param rankOrder Short
         * @param gear Gear
         * @return newInstance
         */
        public static GearPhysicalFeatures newInstance(Date creationDate, Program program, QualityFlag qualityFlag, Vessel vessel, Short rankOrder, Gear gear)
        {
            final GearPhysicalFeatures entity = new GearPhysicalFeaturesImpl();
            entity.setCreationDate(creationDate);
            entity.setProgram(program);
            entity.setQualityFlag(qualityFlag);
            entity.setVessel(vessel);
            entity.setRankOrder(rankOrder);
            entity.setGear(gear);
            return entity;
        }

        /**
         * Constructs a new instance of {@link GearPhysicalFeatures}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param startDate Date
         * @param endDate Date
         * @param creationDate Date
         * @param controlDate Date
         * @param validationDate Date
         * @param qualificationDate Date
         * @param qualificationComments String
         * @param updateDate Timestamp
         * @param remoteId Integer
         * @param program Program
         * @param qualityFlag QualityFlag
         * @param vessel Vessel
         * @param rankOrder Short
         * @param activityCalendar ActivityCalendar
         * @param otherGear Gear
         * @param operations Collection<Operation>
         * @param fishingTrip FishingTrip
         * @param physicalGearSurvey PhysicalGearSurvey
         * @param gear Gear
         * @param gearPhysicalFeaturesOrigins Collection<GearPhysicalFeaturesOrigin>
         * @param metier Metier
         * @param gearPhysicalMeasurements Collection<GearPhysicalMeasurement>
         * @return newInstance GearPhysicalFeatures
         */
        public static GearPhysicalFeatures newInstance(Date startDate, Date endDate, Date creationDate, Date controlDate, Date validationDate, Date qualificationDate, String qualificationComments, Timestamp updateDate, Integer remoteId, Program program, QualityFlag qualityFlag, Vessel vessel, Short rankOrder, ActivityCalendar activityCalendar, Gear otherGear, Collection<Operation> operations, FishingTrip fishingTrip, PhysicalGearSurvey physicalGearSurvey, Gear gear, Collection<GearPhysicalFeaturesOrigin> gearPhysicalFeaturesOrigins, Metier metier, Collection<GearPhysicalMeasurement> gearPhysicalMeasurements)
        {
            final GearPhysicalFeatures entity = new GearPhysicalFeaturesImpl();
            entity.setStartDate(startDate);
            entity.setEndDate(endDate);
            entity.setCreationDate(creationDate);
            entity.setControlDate(controlDate);
            entity.setValidationDate(validationDate);
            entity.setQualificationDate(qualificationDate);
            entity.setQualificationComments(qualificationComments);
            entity.setUpdateDate(updateDate);
            entity.setRemoteId(remoteId);
            entity.setProgram(program);
            entity.setQualityFlag(qualityFlag);
            entity.setVessel(vessel);
            entity.setRankOrder(rankOrder);
            entity.setActivityCalendar(activityCalendar);
            entity.setOtherGear(otherGear);
            entity.setOperations(operations);
            entity.setFishingTrip(fishingTrip);
            entity.setPhysicalGearSurvey(physicalGearSurvey);
            entity.setGear(gear);
            entity.setGearPhysicalFeaturesOrigins(gearPhysicalFeaturesOrigins);
            entity.setMetier(metier);
            entity.setGearPhysicalMeasurements(gearPhysicalMeasurements);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(GearPhysicalFeatures o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getRankOrder() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRankOrder().compareTo(o.getRankOrder()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// GearPhysicalFeatures.java merge-point
}